
Foreman - Bug #6363

Kickstart template doesn't work for host group provisioning: undefined method 'info' for

Hostgroup::Jail

06/24/2014 03:54 PM - Dominic Cleal

Status: New   

Priority: Normal   

Assignee:    

Category: Templates   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

(from https://bugzilla.redhat.com/show_bug.cgi?id=1098183#c9)

1. Created a host group with a dot in the name [new.host]

2. Created a kickstart with a dot in the name [Satellite Kickstart Default for RHEL.v2] which has content same as "Satellite Kickstart

Default for RHEL"

3. Associated the kickstart template with the host group, via "provision templates" -> <template name> -> Association -> "Add

Combination".

4. Generated the PXE default menu by clicking the 'Build PXE Default' button

5. Moved  to /var/lib/tftpboot/pxelinux.cfg on the smartproxy and opened the default file.

6. Tried accessing the link via the browser, 

https://dhcp201-170.englab.pnq.redhat.com/unattended/template/Satellite%20Kickstart%20Default%20for%20RHEL.v2/new.host

But get the below messsage,

"There was an error rendering the  template: undefined method 'info' for Hostgroup::Jail (Hostgroup)"

Related issues:

Related to Foreman - Feature #11628: Check templates when associating with ho... New 09/01/2015

History

#1 - 07/06/2014 03:02 AM - Joseph Magen

- Status changed from New to Assigned

- Assignee set to Adam Heinz

- Target version set to 1.8.1

#2 - 07/06/2014 04:04 AM - Joseph Magen

- Assignee changed from Adam Heinz to Joseph Magen

Is this still a bug if the template is not designed for host group-based provisioning?

I assume we should generated a better error message?

#3 - 07/07/2014 03:32 AM - Dominic Cleal

Joseph Magen wrote:

Is this still a bug if the template is not designed for host group-based provisioning?

 Yes, it's our template.

I assume we should generated a better error message?
 Not really, just fix the template.

#4 - 07/07/2014 03:44 AM - Ohad Levy

Dominic Cleal wrote:

Not really, just fix the template.

wont this add noise to the new template? for example, the following things will never work (maybe missed a couple):

tokens

realms

#5 - 07/07/2014 04:33 AM - Dominic Cleal

Ohad Levy wrote:

Dominic Cleal wrote:

Not really, just fix the template.

wont this add noise to the new template? for example, the following things will never work (maybe missed a couple):

tokens

realms

 Indeed, what are you suggesting?

#6 - 07/07/2014 04:43 AM - Ohad Levy

Dominic Cleal wrote:

Ohad Levy wrote:

Dominic Cleal wrote:

Not really, just fix the template.

wont this add noise to the new template? for example, the following things will never work (maybe missed a couple):

tokens

realms

 Indeed, what are you suggesting?

I see 3 options, which one do you prefer:

1. add checks if hostgroup or host provisioning to every code/snppet (realms, tokens, foreman_url)

2. add a new template type for hostgroup based provisioning

3. break down to more snippets, so the option above is a bit less painful to maintain

any other option?

#7 - 07/07/2014 04:47 AM - Dominic Cleal

I prefer (1), plus (3) if that makes it easier.  I don't think the changes required are too extensive.

#8 - 07/07/2014 07:25 AM - Anonymous

- Target version changed from 1.8.1 to 1.8.0

#9 - 07/30/2014 06:50 AM - Anonymous

- Target version changed from 1.8.0 to 1.7.5

#10 - 07/31/2014 04:39 AM - Stephen Benjamin

- Status changed from Assigned to Ready For Testing

- Assignee changed from Joseph Magen to Stephen Benjamin
PR

https://github.com/theforeman/community-templates/pull/96

#11 - 08/20/2014 06:50 AM - Anonymous

- Target version changed from 1.7.5 to 1.7.4

#12 - 09/10/2014 07:21 AM - Anonymous

- Target version changed from 1.7.4 to 1.7.3

#13 - 09/30/2014 10:43 AM - Dominic Cleal

- Target version changed from 1.7.3 to 1.7.2

#14 - 10/14/2014 01:05 PM - Stephen Benjamin

- Pull request https://github.com/theforeman/community-templates/pull/96 added

- Pull request deleted ()

#15 - 10/14/2014 01:22 PM - Stephen Benjamin

The solution in the above PR is to create a new helper called "host_provision" which will be true in non-hostgroup provisioning.  As Ohad mentioned

above, this takes care of the two issues - relams and tokens.

There is an additional issue in the puppet.conf snippet which calls `certname`, so I've got a check in there - for hostgroup-based provisioning, it'll

replace it with $HOSTNAME, so if the hostname is set then we'll configure it correctly.

That seems to get things up and going for me.

Note these templates will only be compatible with 1.5 and 1.6.

#16 - 03/17/2015 04:34 AM - Lukas Zapletal

- Bugzilla link deleted (1098183)

The BZ link was wrong, it was a different one. But we definitely need to get this downstream. Stephen, are you aware of existing downstream BZ? If

not, I will create/assign to one.

#17 - 09/01/2015 06:03 AM - Lukas Zapletal

- Related to Feature #11628: Check templates when associating with hostgroup added

#18 - 09/01/2015 06:41 AM - Dominic Cleal

- Status changed from Ready For Testing to New

- Assignee deleted (Stephen Benjamin)

- Target version deleted (1.7.2)

- Pull request  added

- Pull request deleted (https://github.com/theforeman/community-templates/pull/96)

#19 - 09/01/2015 07:04 AM - Stephen Benjamin

I don't think so, just #6861 had a bugzilla. I'd just let this whole thing die and tell HG provisioning users to write their own KS.
